<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

/************* Credenziali di Cloudflare *************/
	
$email = ''; //email collegata all'account cloudflare
$domain = ''; //domain.tld, il dominio che vuoi gestire
$api_key = ''; //API Key (va recuperata dal back-end)
$zone_id = ''; //ID Zona (va recuperato dal back-end)
/* Per ogni sito si può usare la stessa apikey perchè è realtiva all'account di Bhoost, va cambiata solo la ZONA ID.*/

/*****************************************************/

class cloudflareApi {
    
    public function getUserDetail($email,$api) {
        $result=$this->curlGetRequest("https://api.cloudflare.com/client/v4/user",$email,$api);
        return $result;
    }
    
    public function purgeFiles($email,$api,$zone_id,$files) {
        $json = json_encode(array(
            'files'=>$files
        ));
        
        $result=$this->curlDeleteRequest("https://api.cloudflare.com/client/v4/zones/".$zone_id."/purge_cache",$email,$api,$json);
        return $result;
    }
    
    public function purgeAll($email,$api,$zone_id) {
        $json = json_encode(array(
            'purge_everything'=>true
        ));
        
        $result=$this->curlDeleteRequest("https://api.cloudflare.com/client/v4/zones/".$zone_id."/purge_cache",$email,$api,$json);
        return $result;
    }
    
    public function getZonesList($email,$api,$domain) {
        $result=$this->curlGetRequest("https://api.cloudflare.com/client/v4/zones?name=$domain",$email,$api);
        return $result;
    }
    
    public function curlGetRequest($url,$email,$api_key) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);

        $headers = array(
            'X-Auth-Email: '.$email,
            'X-Auth-Key: '.$api_key,
            'Content-Type: application/json',
        );
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        curl_close($ch);
        return json_decode($result);
    }
    
    public function curlDeleteRequest($url,$email,$api_key,$json) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $headers = array(
            'X-Auth-Email: '.$email,
            'X-Auth-Key: '.$api_key,
            'Content-Type: application/json'
        );
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        curl_close($ch);
        return json_decode($result);
    }

}

if($email == "" || $api_key == "" || $domain == "" || $zone_id == "") die("Script non configurato!");

$cf = new cloudflareApi();

$responso = $cf->getUserDetail($email,$api_key);
//echo json_encode($responso);
//echo"<pre>";print_r($responso);

if ($responso->success == 1) {
	//$res=$cf->getZonesList($email,$api_key,$domain);
	//echo json_encode($res);
	
	/*$files = '[
	  "http://www.example.com/css/styles1.css",
	  "http://www.example.com/css/styles2.css",
	  "http://www.example.com/css/styles3.css"
	]';
	$res=$cf->purgeFiles($email,$api_key,$zone_id,$files);*/
	//echo json_encode($res);
	
	$res=$cf->purgeAll($email,$api_key,$zone_id);
	//echo json_encode($res);
	if ($res->success == 1)
		echo "La cache di Cloudflare <strong>è stata eliminata correttamente</strong>! Le modifiche dovrebbero essere visibili immediatamente.<br/>In caso contrario, prova a cancellare la cache del browser premendo 'Ctrl+F5'.";
	else 
		echo "<strong>Errore durante l'eliminazione</strong> della cache di Cloudflare.<br/>Accedi a Cloudflare ed eliminala manualmente!";
} else {
	echo "Errore autenticazione!";
}